blob: 74a62617646ce8072f1f7eda623f34ff4bc22674 [file] [log] [blame]
Peter Stuge09377b72011-08-21 06:24:55 +02001#!/bin/sh
Stefan Reinauer074d9132009-09-26 16:43:17 +00002#
Stefan Reinauer5f1ad892010-05-17 11:02:25 +00003# Copyright (C) 2008-2010 by coresystems GmbH
Stefan Reinauer074d9132009-09-26 16:43:17 +00004# written by Patrick Georgi <patrick.georgi@coresystems.de> and
5# Stefan Reinauer <stefan.reinauer@coresystems.de>
Stefan Reinauer14e22772010-04-27 06:56:47 +00006#
Marc Jones2aac3f62011-08-08 16:07:50 -06007# Copyright (C) 2011 by Sage Electronic Engineering
8#
Stefan Reinauer074d9132009-09-26 16:43:17 +00009# This program is free software; you can redistribute it and/or modify
10# it under the terms of the GNU General Public License as published by
11# the Free Software Foundation; version 2 of the License.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16# GNU General Public License for more details.
17#
Stefan Reinauer074d9132009-09-26 16:43:17 +000018
Stefan Reinauerd7649122015-06-09 11:44:25 -070019cd $(dirname $0)
Patrick Georgi8135dba2015-03-17 21:05:20 +010020
Martin Roth2ab981b2016-08-31 16:43:49 -060021CROSSGCC_DATE="August 31st, 2016"
22CROSSGCC_VERSION="1.43"
Stefan Reinauer88352d72016-04-06 15:57:03 -070023CROSSGCC_COMMIT=$( git describe )
Stefan Reinauer074d9132009-09-26 16:43:17 +000024
25# default settings
Stefan Reinauer85b07d62015-06-09 14:45:14 -070026PACKAGE=GCC
Stefan Reinauerd7649122015-06-09 11:44:25 -070027TARGETDIR=$(pwd)/xgcc
Stefan Reinauer074d9132009-09-26 16:43:17 +000028TARGETARCH=i386-elf
Nico Huber32c4a062016-01-25 18:30:57 +010029LANGUAGES=c
Stefan Reinauer074d9132009-09-26 16:43:17 +000030DESTDIR=
Stefan Reinauer85b07d62015-06-09 14:45:14 -070031SAVETEMPS=0
32SKIPPYTHON=1
Nico Huber234d2462016-01-26 16:10:17 +010033BOOTSTRAP=0
Stefan Reinauer074d9132009-09-26 16:43:17 +000034
Stefan Reinauer699ac272015-06-05 12:43:28 -070035# GCC toolchain version numbers
Timothy Pearson96310162015-12-28 22:53:29 -060036GMP_VERSION=6.1.0
Iru Caiae8e3a02016-04-02 10:50:59 +080037MPFR_VERSION=3.1.4
Paul Menzele6619422015-02-23 10:33:59 +010038MPC_VERSION=1.0.3
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000039LIBELF_VERSION=0.8.13
Iru Caiae8e3a02016-04-02 10:50:59 +080040GCC_VERSION=5.3.0
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070041GCC_AUTOCONF_VERSION=2.69
Martin Rothbcfa7cc2016-07-14 13:01:37 -060042BINUTILS_VERSION=2.26.1
Stefan Reinauer498f3d02016-04-21 18:10:15 -070043GDB_VERSION=7.11
Martin Roth2ab981b2016-08-31 16:43:49 -060044IASL_VERSION=20160831
Stefan Reinauer3dc5d072016-04-21 19:29:03 -070045PYTHON_VERSION=3.5.1
Stefan Reinauer498f3d02016-04-21 18:10:15 -070046EXPAT_VERSION=2.1.1
Stefan Reinauer14ce2132015-06-05 13:01:13 -070047# CLANG version number
Iru Caiae8e3a02016-04-02 10:50:59 +080048CLANG_VERSION=3.8.0
Martin Roth589ef9d2016-08-11 18:35:06 -060049MAKE_VERSION=4.2.1
Stefan Reinauer074d9132009-09-26 16:43:17 +000050
Stefan Reinauer699ac272015-06-05 12:43:28 -070051# GCC toolchain archive locations
Martin Roth1484c032016-03-08 09:37:14 -070052# These are sanitized by the jenkins toolchain test builder, so if
53# a completely new URL is added here, it probably needs to be added
54# to the jenkins build as well, or the builder won't download it.
Stefan Reinauerd9d21022016-04-21 18:16:30 -070055GMP_ARCHIVE="http://ftpmirror.gnu.org/gmp/gmp-${GMP_VERSION}.tar.xz"
56MPFR_ARCHIVE="http://ftpmirror.gnu.org/mpfr/mpfr-${MPFR_VERSION}.tar.xz"
Idwer Vollering7962fc72012-10-25 02:14:09 +020057MPC_ARCHIVE="http://ftpmirror.gnu.org/mpc/mpc-${MPC_VERSION}.tar.gz"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000058LIBELF_ARCHIVE="http://www.mr511.de/software/libelf-${LIBELF_VERSION}.tar.gz"
Idwer Vollering1cfee0b2012-10-25 02:03:53 +020059GCC_ARCHIVE="http://ftpmirror.gnu.org/gcc/gcc-${GCC_VERSION}/gcc-${GCC_VERSION}.tar.bz2"
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070060BINUTILS_ARCHIVE="http://ftpmirror.gnu.org/binutils/binutils-${BINUTILS_VERSION}.tar.bz2"
Patrick Georgi53c388f2015-03-07 09:55:18 +010061GDB_ARCHIVE="http://ftpmirror.gnu.org/gdb/gdb-${GDB_VERSION}.tar.xz"
Patrick Georgi85bb9462016-02-11 17:22:16 +010062IASL_ARCHIVE="https://acpica.org/sites/acpica/files/acpica-unix2-${IASL_VERSION}.tar.gz"
Patrick Georgi53c388f2015-03-07 09:55:18 +010063PYTHON_ARCHIVE="http://www.python.org/ftp/python/${PYTHON_VERSION}/Python-${PYTHON_VERSION}.tar.xz"
Stefan Reinauer498f3d02016-04-21 18:10:15 -070064EXPAT_ARCHIVE="http://downloads.sourceforge.net/sourceforge/expat/expat-${EXPAT_VERSION}.tar.bz2"
Stefan Reinauer14ce2132015-06-05 13:01:13 -070065# CLANG toolchain archive locations
66LLVM_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/llvm-${CLANG_VERSION}.src.tar.xz"
67CFE_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/cfe-${CLANG_VERSION}.src.tar.xz"
68CRT_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/compiler-rt-${CLANG_VERSION}.src.tar.xz"
69CTE_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/clang-tools-extra-${CLANG_VERSION}.src.tar.xz"
Stefan Reinauera851bbb2016-01-29 18:03:26 -080070MAKE_ARCHIVE="http://ftpmirror.gnu.org/make/make-${MAKE_VERSION}.tar.bz2"
Stefan Reinauer074d9132009-09-26 16:43:17 +000071
Martin Roth58c68d52016-03-01 15:22:42 -070072ALL_ARCHIVES="$GMP_ARCHIVE $MPFR_ARCHIVE $MPC_ARCHIVE $LIBELF_ARCHIVE \
73 $GCC_ARCHIVE $BINUTILS_ARCHIVE $GDB_ARCHIVE $IASL_ARCHIVE \
74 $PYTHON_ARCHIVE $EXPAT_ARCHIVE $LLVM_ARCHIVE $CFE_ARCHIVE \
75 $CRT_ARCHIVE $CTE_ARCHIVE $MAKE_ARCHIVE"
76
Stefan Reinauer699ac272015-06-05 12:43:28 -070077# GCC toolchain directories
Stefan Reinauer074d9132009-09-26 16:43:17 +000078GMP_DIR="gmp-${GMP_VERSION}"
79MPFR_DIR="mpfr-${MPFR_VERSION}"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000080MPC_DIR="mpc-${MPC_VERSION}"
81LIBELF_DIR="libelf-${LIBELF_VERSION}"
Stefan Reinauer074d9132009-09-26 16:43:17 +000082GCC_DIR="gcc-${GCC_VERSION}"
83BINUTILS_DIR="binutils-${BINUTILS_VERSION}"
84GDB_DIR="gdb-${GDB_VERSION}"
Patrick Georgi85bb9462016-02-11 17:22:16 +010085IASL_DIR="acpica-unix2-${IASL_VERSION}"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010086PYTHON_DIR="Python-${PYTHON_VERSION}"
87EXPAT_DIR="expat-${EXPAT_VERSION}"
Stefan Reinauer14ce2132015-06-05 13:01:13 -070088# CLANG toolchain directories
89LLVM_DIR="llvm-${CLANG_VERSION}.src"
90CFE_DIR="cfe-${CLANG_VERSION}.src"
91CRT_DIR="compiler-rt-${CLANG_VERSION}.src"
92CTE_DIR="clang-tools-extra-${CLANG_VERSION}.src"
Stefan Reinauera851bbb2016-01-29 18:03:26 -080093MAKE_DIR="make-${MAKE_VERSION}"
Stefan Reinauer074d9132009-09-26 16:43:17 +000094
Patrick Georgi6321f522015-02-27 23:36:26 +010095unset MAKELEVEL MAKEFLAGS
96
Patrick Georgi1861ff72011-10-31 12:15:55 +010097red='\033[0;31m'
98RED='\033[1;31m'
99green='\033[0;32m'
100GREEN='\033[1;32m'
101blue='\033[0;34m'
102BLUE='\033[1;34m'
103cyan='\033[0;36m'
104CYAN='\033[1;36m'
105NC='\033[0m' # No Color
Stefan Reinauer074d9132009-09-26 16:43:17 +0000106
zbaoe05c1ea2015-08-05 23:10:05 -0400107UNAME=$(uname | grep -iq cygwin && echo Cygwin || uname)
Martin Roth88463822016-01-07 11:03:36 -0700108HALT_FOR_TOOLS=0
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700109
Patrick Georgi198d23c2012-12-08 08:02:44 +0100110normalize_dirs()
111{
112 mkdir -p $DESTDIR$TARGETDIR/lib
113 test -d $DESTDIR$TARGETDIR/lib32 && mv $DESTDIR$TARGETDIR/lib32/* $DESTDIR$TARGETDIR/lib
114 test -d $DESTDIR$TARGETDIR/lib64 && mv $DESTDIR$TARGETDIR/lib64/* $DESTDIR$TARGETDIR/lib
115 rmdir -p $DESTDIR$TARGETDIR/lib32 $DESTDIR$TARGETDIR/lib64
116
117 perl -pi -e "s,/lib32,/lib," $DESTDIR$TARGETDIR/lib/*.la
118 perl -pi -e "s,/lib64,/lib," $DESTDIR$TARGETDIR/lib/*.la
119}
120
Stefan Reinauer93a96302015-06-15 12:36:53 -0700121please_install()
122{
Martin Roth88463822016-01-07 11:03:36 -0700123 HALT_FOR_TOOLS=1
Patrick Georgi5da95dc2015-07-17 23:33:05 +0200124 test -r /etc/os-release && . /etc/os-release
Stefan Reinauer93a96302015-06-15 12:36:53 -0700125 case "$ID_LIKE" in
126 debian) solution="sudo apt-get install $1" ;;
127 suse) solution="sudo zypper install $1" ;;
128 *) solution="using your OS packaging system" ;;
129 esac
130
Martin Roth591790f2016-03-20 20:39:04 -0600131 printf "${RED}ERROR:${red} Missing tool: Please install \'$1\'. (eg $solution)${NC}\n" >&2
Martin Rothe3963172016-01-06 13:54:32 -0700132 if [ -n "$2" ]; then
Martin Roth591790f2016-03-20 20:39:04 -0600133 printf "${RED}ERROR:${red} or install \'$2\'.${NC}\n" >&2
Martin Rothe3963172016-01-06 13:54:32 -0700134 fi
Stefan Reinauer93a96302015-06-15 12:36:53 -0700135}
136
Patrick Georgib7062882015-02-24 10:52:14 +0100137searchtool()
Stefan Reinauer074d9132009-09-26 16:43:17 +0000138{
139 # $1 short name
Patrick Georgib7062882015-02-24 10:52:14 +0100140 # $2 search string
141 # $3 soft fail if set
Martin Rothe3963172016-01-06 13:54:32 -0700142 # $4 alternative package to install on failure
Patrick Georgib7062882015-02-24 10:52:14 +0100143 # result: file name of that tool on stdout
144 # or no output if nothing suitable was found
145 search=GNU
146 if [ -n "$2" ]; then
147 search="$2"
148 fi
Stefan Reinauer074d9132009-09-26 16:43:17 +0000149 for i in "$1" "g$1" "gnu$1"; do
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700150 if [ -x "$(which $i 2>/dev/null)" ]; then
151 if [ "$(cat /dev/null | $i --version 2>&1 | grep -c "$search")" \
152 -gt 0 ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000153 echo $i
154 return
155 fi
156 fi
157 done
Andrew Wub67e9a12014-04-28 18:13:44 +0800158 # A workaround for OSX 10.9 and some BSDs, whose nongnu
159 # patch and tar also work.
Patrick Georgi7cb26b42015-04-28 21:29:22 +0200160 if [ $UNAME = "Darwin" -o $UNAME = "FreeBSD" -o $UNAME = "NetBSD" -o $UNAME = "OpenBSD" ]; then
Patrick Georgib7062882015-02-24 10:52:14 +0100161 if [ "$1" = "patch" -o "$1" = "tar" ]; then
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700162 if [ -x "$(which $1 2>/dev/null)" ]; then
Zheng Bao36156ff2012-09-28 16:18:58 +0800163 echo $1
164 return
165 fi
166 fi
167 fi
zbao5cf758d2015-09-01 22:28:57 -0400168 if echo $1 | grep -q "sum" ; then
169 algor=$(echo $1 | sed -e 's,sum,,')
170 if [ -x "$(which $1 2>/dev/null)" ]; then
171 #xxxsum [file]
172 echo $1
173 return
174 elif [ -x "$(which $algor 2>/dev/null)" ]; then
175 #xxx [file]
176 echo $algor
177 return
178 elif [ -x "$(which openssl 2>/dev/null)" ]; then
179 #openssl xxx [file]
180 echo openssl $algor
181 return
182 elif [ -x "$(which cksum 2>/dev/null)" ]; then
183 #cksum -a xxx [file]
184 #cksum has special options in NetBSD. Actually, NetBSD will use the second case above.
185 echo "buildgcc" | cksum -a $algor > /dev/null 2>/dev/null && \
186 echo cksum -a $algor
187 return
zbao939dc842015-04-30 04:44:07 +0800188 fi
189 fi
Martin Rothe3963172016-01-06 13:54:32 -0700190
Martin Roth88463822016-01-07 11:03:36 -0700191 [ -z "$3" ] && please_install $1 $4
Patrick Georgib7062882015-02-24 10:52:14 +0100192 false
Stefan Reinauer074d9132009-09-26 16:43:17 +0000193}
194
Martin Roth591790f2016-03-20 20:39:04 -0600195# Run a compile check of the specified library option to see if it's installed
196check_for_library() {
197 local LIBRARY_FLAGS=$1
Aaron Durbin0ac4e5a2016-04-07 16:56:25 -0500198 local LIBRARY_PACKAGES="$2"
Martin Roth591790f2016-03-20 20:39:04 -0600199 local LIBTEST_FILE=.libtest
200
201 echo "int main(int argc, char **argv) { (void) argc; (void) argv; return 0; }" > "${LIBTEST_FILE}.c"
202
203 cc $CFLAGS $LIBRARY_FLAGS "${LIBTEST_FILE}.c" -o "${LIBTEST_FILE}" >/dev/null 2>&1 || \
204 please_install "$LIBRARY_PACKAGES"
205 rm -rf "${LIBTEST_FILE}.c" "${LIBTEST_FILE}"
206}
207
Nico Huberaee7f462016-09-20 12:55:19 +0200208buildcc_major() {
209 echo "${GCC_VERSION}" | cut -d. -f1
210}
211
212buildcc_version() {
213 echo "${GCC_VERSION}" | cut -d. -f1-2
214}
215
216hostcc_major() {
217 (echo __GNUC__ | ${CC} -E - 2>/dev/null || echo 0) | tail -1
218}
219
220hostcc_minor() {
221 (echo __GNUC_MINOR__ | ${CC} -E - 2>/dev/null || echo 0) | tail -1
222}
223
224hostcc_version() {
225 printf "%d.%d" "$(hostcc_major)" "$(hostcc_minor)"
226}
227
Nico Huber75797162016-09-20 13:01:57 +0200228hostcc_has_gnat1() {
229 [ -x "$(${CC} -print-prog-name=gnat1)" ]
230}
231
232ada_requested() {
233 echo "${LANGUAGES}" | grep -q '\<ada\>'
234}
235
236check_gnat() {
237 if hostcc_has_gnat1; then
238 if [ "$(hostcc_version)" != "$(buildcc_version)" -a "${BOOTSTRAP}" != "1" ]; then
239 printf "\n${RED}ERROR:${red} Building the Ada compiler (gnat $(buildcc_version)) "
240 printf "with a different host compiler\n version ($(hostcc_version)) "
241 printf "requires bootstrapping (-b).${NC}\n\n"
242 HALT_FOR_TOOLS=1
243 fi
Nico Huber04a1f6a2016-09-20 13:07:49 +0200244 else
245 please_install gnat
Nico Huber75797162016-09-20 13:01:57 +0200246 fi
247}
248
Nico Huber156d87c2016-09-20 12:59:53 +0200249check_cc() {
250 if is_package_enabled "GCC"; then
251 if [ "$(hostcc_major)" != "$(buildcc_major)" -a "${BOOTSTRAP}" != "1" ]; then
252 printf "\n${red}warning: Building GCC $(buildcc_version) with a different major "
253 printf "version ($(hostcc_version)).\n"
254 printf " Bootstrapping (-b) is recommended.${NC}\n\n"
255 fi
Nico Huber75797162016-09-20 13:01:57 +0200256 if ada_requested; then
257 check_gnat
258 fi
Nico Huber156d87c2016-09-20 12:59:53 +0200259 fi
260}
261
zbao06e85ac2015-08-24 22:08:36 -0400262check_sum() {
263 test -z "$CHECKSUM" || \
264 test "$(cat sum/$1.cksum 2>/dev/null | sed -e 's@.*\([0-9a-f]\{40,\}\).*@\1@')" = \
265 "$($CHECKSUM tarballs/$1 2>/dev/null | sed -e 's@.*\([0-9a-f]\{40,\}\).*@\1@')"
266}
267
268compute_sum() {
269 test ! -f sum/$1.cksum && test -f tarballs/$1 && \
270 (test -z "$CHECKSUM" || $CHECKSUM tarballs/$1 > sum/$1.cksum ) && \
271 printf "(checksum created. ${RED}Note. Please upload sum/$1.cksum if the corresponding archive is upgraded.)${NC}"
272}
273
zbao282dd952015-09-06 05:00:04 -0400274download_showing_percentage() {
275 url=$1
276 printf " ..${red} 0%%"
277 wget --no-check-certificate $url 2>&1 | while read line; do
zbao282dd952015-09-06 05:00:04 -0400278 echo $line | grep -o "[0-9]\+%" | awk '{printf("\b\b\b\b%4s", $1)}'
zbao282dd952015-09-06 05:00:04 -0400279 done
Zheng Baobb003c82016-08-05 13:41:51 +0800280 printf "${NC}"
zbao282dd952015-09-06 05:00:04 -0400281}
282
Stefan Reinauer88935482015-06-05 09:51:10 -0700283download() {
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700284 package=$1
285 archive="$(eval echo \$$package"_ARCHIVE")"
Stefan Reinauer699ac272015-06-05 12:43:28 -0700286
Stefan Reinauerd7649122015-06-09 11:44:25 -0700287 FILE=$(basename $archive)
Stefan Reinauer88935482015-06-05 09:51:10 -0700288 printf " * $FILE "
289
zbaod22b9ea2015-08-30 23:35:16 -0400290 if test -f tarballs/$FILE && check_sum $FILE ; then
291 printf "(cached)"
292 else
Paul Menzelb2ba3952015-06-12 11:58:14 +0200293 printf "(downloading from $archive)"
Stefan Reinauer88935482015-06-05 09:51:10 -0700294 rm -f tarballs/$FILE
295 cd tarballs
zbao282dd952015-09-06 05:00:04 -0400296 download_showing_percentage $archive
Stefan Reinauer88935482015-06-05 09:51:10 -0700297 cd ..
zbao06e85ac2015-08-24 22:08:36 -0400298 compute_sum $FILE
zbaod22b9ea2015-08-30 23:35:16 -0400299 fi
300
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700301 if [ ! -f tarballs/$FILE ]; then
zbao282dd952015-09-06 05:00:04 -0400302 printf "\n${RED}Failed to download $FILE.${NC}\n"
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700303 exit 1
304 fi
Stefan Reinauer88935482015-06-05 09:51:10 -0700305 printf "\n"
306}
307
308unpack_and_patch() {
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700309 package=$1
310 archive="$(eval echo \$$package"_ARCHIVE")"
311 dir="$(eval echo \$$package"_DIR")"
Stefan Reinauer88935482015-06-05 09:51:10 -0700312 test -d ${dir} && test -f ${dir}/.unpack_success || (
Stefan Reinauerd7649122015-06-09 11:44:25 -0700313 printf " * $(basename $archive)\n"
Stefan Reinauer88935482015-06-05 09:51:10 -0700314 FLAGS=zxf
Stefan Reinauerd7649122015-06-09 11:44:25 -0700315 suffix=$(echo $archive | sed 's,.*\.,,')
Martin Roth95f7b222016-03-20 12:38:48 -0600316 if [ "$suffix" = "gz" ] && [ -n "$PIGZ" ]; then FLAGS="-I pigz -xf"
317 elif [ "$suffix" = "gz" ]; then FLAGS=zxf
318 elif [ "$suffix" = "bz2" ] && [ -n "$LBZIP2" ]; then FLAGS="-I lbzip2 -xf"
319 elif [ "$suffix" = "bz2" ]; then FLAGS=jxf
320 elif [ "$suffix" = "xz" ]; then FLAGS="--xz -xf"
321 elif [ "$suffix" = "lzma" ]; then FLAGS="--lzma -xf"
322 fi
Stefan Reinauerd7649122015-06-09 11:44:25 -0700323 $TAR $FLAGS tarballs/$(basename $archive)
Stefan Reinauer88935482015-06-05 09:51:10 -0700324 for patch in patches/${dir}_*.patch; do
325 test -r $patch || continue
Stefan Reinauerd7649122015-06-09 11:44:25 -0700326 printf " o $(basename $patch)\n"
Nico Huber4b48ed82016-07-27 00:28:03 +0200327 (cd ${dir} && $PATCH -s -N -p1 <../${patch}) || {
Stefan Reinauer88935482015-06-05 09:51:10 -0700328 printf "\n${RED}Failed $patch.${NC}\n"
Stefan Reinauer916b8452015-06-09 11:54:49 -0700329 exit 1
330 }
Stefan Reinauer88935482015-06-05 09:51:10 -0700331 done
332 touch ${dir}/.unpack_success
333 )
334}
335
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700336fn_exists()
337{
Patrick Georgic8665912015-06-11 21:04:31 +0200338 type $1 >/dev/null 2>&1
Patrick Georgi74c06422015-03-25 18:40:13 +0100339}
340
Patrick Georgif2c15f52015-06-11 21:07:31 +0200341is_package_enabled()
342{
343 echo "$PACKAGES" |grep -q "\<$1\>"
344}
345
Martin Roth444ece22016-04-01 18:46:29 -0600346package_uses_targetarch()
347{
Stefan Reinauera344b682016-04-21 19:29:51 -0700348 if [ "$1" = "GCC" ] || [ "$1" = "GDB" ] || [ "$1" = "BINUTILS" ]; then
Martin Roth444ece22016-04-01 18:46:29 -0600349 true
350 else
351 false
352 fi
353}
354
Nico Huber11ea2b32016-01-26 16:09:31 +0100355generic_build()
356{
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700357 package=$1
Nico Huber11ea2b32016-01-26 16:09:31 +0100358 host_target=$2
359 builddir=$3
360 success=$4
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700361
362 fn_exists build_$package || return
363
Stefan Reinauer05bbc9202015-06-09 12:21:42 -0700364 version="$(eval echo \$$package"_VERSION")"
Stefan Reinauer05bbc9202015-06-09 12:21:42 -0700365
Nico Huber11ea2b32016-01-26 16:09:31 +0100366 mkdir -p "$builddir"
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700367
Nico Huber11ea2b32016-01-26 16:09:31 +0100368 if [ -f "$success" ]; then
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700369 printf "Skipping $package as it is already built\n"
370 else
371 printf "Building $package $version ... "
Nico Huber11ea2b32016-01-26 16:09:31 +0100372 DIR="$PWD"
373 cd "$builddir"
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700374 rm -f .failed
Nico Huber11ea2b32016-01-26 16:09:31 +0100375 build_${package} $host_target > build.log 2>&1
376 cd "$DIR"
377 if [ ! -f "$builddir/.failed" ]; then
378 touch "$success";
379 else
380 printf "${RED}failed${NC}. Check $builddir/build.log.\n"
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700381 exit 1
382 fi
383 printf "${green}ok${NC}\n"
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700384 fi
385}
386
Nico Huber11ea2b32016-01-26 16:09:31 +0100387build_for_host()
388{
389 generic_build $1 host build-$1 "${TARGETDIR}/.$1.success"
390}
391
392build_for_target()
393{
394 generic_build $1 target build-${TARGETARCH}-$1 "${TARGETDIR}/.${TARGETARCH}-$1.success"
395}
396
397build()
398{
399 if package_uses_targetarch $1; then
Nico Huber234d2462016-01-26 16:10:17 +0100400 if [ $BOOTSTRAP -eq 1 -a ! -f "${TARGETDIR}/.GCC.success" ]; then
401 build_for_host GCC
402 fi
Nico Huber11ea2b32016-01-26 16:09:31 +0100403 build_for_target $1
404 else
405 build_for_host $1
406 fi
407}
408
Zheng Baobb003c82016-08-05 13:41:51 +0800409quit()
410{
411 printf "${NC}Stop\n"
412 exit 1
413}
414
Stefan Reinauer074d9132009-09-26 16:43:17 +0000415cleanup()
416{
Stefan Reinauer88e83e52016-04-06 15:39:48 -0700417 if [ $SAVETEMPS -ne 0 ]; then
418 printf "Leaving temporary files around... ${green}ok${NC}\n"
419 return
420 fi
421
Stefan Reinauer074d9132009-09-26 16:43:17 +0000422 printf "Cleaning up temporary files... "
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700423 for package in $PACKAGES; do
Martin Roth444ece22016-04-01 18:46:29 -0600424 rm -rf build-${TARGETARCH}-$package build-$package $(eval echo \$$package"_DIR")
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700425 done
zbaoff3f15c2015-08-26 22:00:31 -0400426 rm -f getopt
Stefan Reinauer074d9132009-09-26 16:43:17 +0000427 printf "${green}ok${NC}\n"
428}
429
430myhelp()
431{
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700432 printf "Usage: $0 [-V] [-c] [-p <platform>] [-d <target directory>] [-D <dest dir>] [-C] [-G] [-S]\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000433 printf " $0 [-V|--version]\n"
434 printf " $0 [-h|--help]\n\n"
435
436 printf "Options:\n"
437 printf " [-V|--version] print version number and exit\n"
438 printf " [-h|--help] print this help and exit\n"
439 printf " [-c|--clean] remove temporary files before build\n"
440 printf " [-t|--savetemps] don't remove temporary files after build\n"
Patrick Georgic1a75b12011-11-04 21:37:14 +0100441 printf " [-y|--ccache] Use ccache when building cross compiler\n"
Nico Huber152e78e2016-09-20 15:38:40 +0200442 printf " [-n|--nocolor] don't print color codes in output\n"
443 printf " [-u|--urls] print the urls for all packages\n"
Patrick Georgi73166c72010-04-14 20:42:42 +0000444 printf " [-j|--jobs <num>] run <num> jobs in parallel in make\n"
Martin Roth588c79d2016-03-20 12:03:20 -0600445 printf " [-s]--supported <tool> print supported version of a tool\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000446 printf " [-d|--directory <target dir>] target directory to install cross compiler to\n"
Martin Roth588c79d2016-03-20 12:03:20 -0600447 printf " (defaults to $TARGETDIR)\n\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000448 printf " [-D|--destdir <dest dir>] destination directory to install cross compiler to\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100449 printf " (for RPM builds, default unset)\n"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700450 printf " [-P|--package <package>] Build a specific package: GCC, CLANG, IASL, GDB\n"
451 printf " (defaults to $PACKAGE)\n"
452 printf "GCC specific options:\n"
Nico Huber234d2462016-01-26 16:10:17 +0100453 printf " [-b|--bootstrap] bootstrap the host compiler before building\n"
454 printf " the cross compiler\n"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700455 printf " [-p|--platform <platform>] target platform to build cross compiler for\n"
456 printf " (defaults to $TARGETARCH)\n"
Nico Huberbb313bf2015-09-08 12:30:27 +0200457 printf " [-l|--languages <languages>] comma separated list of target languages\n"
458 printf " (defaults to $LANGUAGES)\n"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700459 printf "GDB specific options:\n"
460 printf " [-p|--platform <platform>] target platform to build cross compiler for\n"
461 printf " (defaults to $TARGETARCH)\n"
462 printf " [-S|--scripting] build scripting support for GDB\n\n"
Martin Rothd1da74f2015-06-21 12:06:28 -0600463 printf "Platforms for GCC & GDB:\n"
Martin Roth3e0f74d2016-03-08 12:07:04 -0700464 printf " x86_64 i386-elf i386-mingw32 mipsel-elf riscv-elf arm aarch64\n"
Jonathan Neuschäferf14f6402016-03-11 20:22:23 +0100465 printf " powerpc64le-linux-gnu nds32le-elf\n\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000466}
467
Martin Rothedf965a2015-11-25 16:58:33 -0700468printversion() {
469 printf "${blue}Welcome to the ${red}coreboot${blue} cross toolchain builder v$CROSSGCC_VERSION ($CROSSGCC_DATE)${NC}\n\n"
470}
471
Stefan Reinauer074d9132009-09-26 16:43:17 +0000472myversion()
473{
Martin Rothedf965a2015-11-25 16:58:33 -0700474 printversion
Stefan Reinauer074d9132009-09-26 16:43:17 +0000475
476 cat << EOF
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000477Copyright (C) 2008-2010 by coresystems GmbH
Marc Jones2aac3f62011-08-08 16:07:50 -0600478Copyright (C) 2011 by Sage Electronic Engineering
Stefan Reinauer074d9132009-09-26 16:43:17 +0000479
480This program is free software; you can redistribute it and/or modify
481it under the terms of the GNU General Public License as published by
482the Free Software Foundation; version 2 of the License.
483
484This program is distributed in the hope that it will be useful,
485but WITHOUT ANY WARRANTY; without even the implied warranty of
486MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
487GNU General Public License for more details.
488
489EOF
490}
491
Nico Huber5f72f962016-01-31 23:05:19 +0100492have_hostcflags_from_gmp() {
493 grep -q __GMP_CFLAGS $DESTDIR$TARGETDIR/include/gmp.h >/dev/null 2>&1
494}
495
496set_hostcflags_from_gmp() {
497 # Now set CFLAGS to match GMP CFLAGS but strip out -pedantic
498 # as GCC 4.6.x fails if it's there.
Idwer Volleringba349ab2016-07-24 02:10:19 +0200499 export HOSTCFLAGS="$(grep __GMP_CFLAGS $DESTDIR$TARGETDIR/include/gmp.h |cut -d\" -f2 |\
500 sed s,-pedantic,,)"
Nico Huber5f72f962016-01-31 23:05:19 +0100501}
502
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700503build_GMP() {
Paul Kocialkowski7899db22016-06-17 21:41:00 -0700504 CC="$CC" ../${GMP_DIR}/configure --disable-shared --enable-fat \
Nico Huber5f72f962016-01-31 23:05:19 +0100505 --prefix=$TARGETDIR $OPTIONS \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700506 || touch .failed
507 $MAKE $JOBS || touch .failed
508 $MAKE install DESTDIR=$DESTDIR || touch .failed
509
510 normalize_dirs
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700511
Nico Huber5f72f962016-01-31 23:05:19 +0100512 set_hostcflags_from_gmp
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700513}
514
515build_MPFR() {
516 test $UNAME = "Darwin" && CFLAGS="$CFLAGS -force_cpusubtype_ALL"
517 CC="$CC" ../${MPFR_DIR}/configure --disable-shared --prefix=$TARGETDIR \
518 --infodir=$TARGETDIR/info \
519 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
520 touch .failed
521 $MAKE $JOBS || touch .failed
522 $MAKE install DESTDIR=$DESTDIR || touch .failed
523
524 normalize_dirs
525
526 # work around build problem of libgmp.la
527 if [ "$DESTDIR" != "" ]; then
528 perl -pi -e "s,$DESTDIR,," $DESTDIR$TARGETDIR/libgmp.la
529 fi
530}
531
532build_MPC() {
533 CC="$CC" ../${MPC_DIR}/configure --disable-shared --prefix=$TARGETDIR \
534 --infodir=$TARGETDIR/info --with-mpfr=$DESTDIR$TARGETDIR \
535 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
536 touch .failed
537 $MAKE $JOBS || touch .failed
538 $MAKE install DESTDIR=$DESTDIR || touch .failed
539
540 normalize_dirs
541}
542
543build_LIBELF() {
544 CC="$CC" CFLAGS="$HOSTCFLAGS" libelf_cv_elf_h_works=no \
545 ../${LIBELF_DIR}/configure --disable-shared --prefix=$TARGETDIR \
546 --infodir=$TARGETDIR/info CFLAGS="$HOSTCFLAGS" || touch .failed
547 $MAKE $JOBS || touch .failed
548 $MAKE install prefix=$DESTDIR$TARGETDIR || touch .failed
549
550 normalize_dirs
551}
552
553build_BINUTILS() {
Stefan Reinauer682a90c2015-06-09 14:59:58 -0700554 if [ $TARGETARCH == "x86_64-elf" ]; then
555 ADDITIONALTARGET=",i386-elf"
556 fi
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700557 CC="$CC" ../binutils-${BINUTILS_VERSION}/configure --prefix=$TARGETDIR \
Stefan Reinauer682a90c2015-06-09 14:59:58 -0700558 --target=${TARGETARCH} --enable-targets=${TARGETARCH}${ADDITIONALTARGET} \
559 --disable-werror --disable-nls --enable-lto --enable-gold \
Stefan Reinauer2fe2d3d2016-04-05 02:14:48 -0700560 --enable-interwork --enable-multilib \
Stefan Reinauer682a90c2015-06-09 14:59:58 -0700561 --enable-plugins --enable-multilibs CFLAGS="$HOSTCFLAGS" || touch .failed
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700562 $MAKE $JOBS || touch .failed
563 $MAKE install DESTDIR=$DESTDIR || touch .failed
564}
565
Nico Huber234d2462016-01-26 16:10:17 +0100566bootstrap_GCC() {
567 CC="$CC" \
568 CFLAGS="$HOSTCFLAGS" \
569 CFLAGS_FOR_BUILD="$HOSTCFLAGS" \
570 CFLAGS_FOR_TARGET="$HOSTCFLAGS -fPIC" \
571 CXXFLAGS="$HOSTCFLAGS" \
572 CXXFLAGS_FOR_BUILD="$HOSTCFLAGS" \
573 CXXFLAGS_FOR_TARGET="$HOSTCFLAGS -fPIC" \
574 ../gcc-${GCC_VERSION}/configure \
575 --prefix=$TARGETDIR --libexecdir=$TARGETDIR/lib \
576 --enable-bootstrap \
577 --disable-werror --disable-nls \
578 --disable-shared --disable-multilib \
579 --disable-libssp --disable-libquadmath --disable-libcc1 \
580 ${GCC_OPTIONS} --enable-languages="${LANGUAGES}" \
581 --with-gmp=$DESTDIR$TARGETDIR --with-mpfr=$DESTDIR$TARGETDIR \
582 --with-mpc=$DESTDIR$TARGETDIR --with-libelf=$DESTDIR$TARGETDIR \
583 --with-pkgversion="coreboot bootstrap v$CROSSGCC_VERSION $CROSSGCC_DATE" \
584 && \
585 $MAKE $JOBS BOOT_CFLAGS="$HOSTCFLAGS" BUILD_CONFIG="" bootstrap && \
586 $MAKE install-gcc \
587 install-target-libgcc \
588 maybe-install-target-libada \
589 maybe-install-target-libstdc++-v3 \
590 DESTDIR=$DESTDIR && \
591 ln -s gcc $DESTDIR$TARGETDIR/bin/cc || touch .failed
592}
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700593
Nico Huber234d2462016-01-26 16:10:17 +0100594build_cross_GCC() {
Stefan Reinauer45f77b82016-04-03 20:52:01 -0700595 # Work around crazy code generator in GCC that confuses CLANG.
Aaron Durbinb2229dc2016-04-07 16:58:10 -0500596 $CC --version | grep clang >/dev/null 2>&1 && \
Stefan Reinauer45f77b82016-04-03 20:52:01 -0700597 HOSTCFLAGS="$HOSTCFLAGS -fbracket-depth=1024"
598
Stefan Reinauerd0f83722015-06-09 11:52:28 -0700599 # GCC does not honor HOSTCFLAGS at all. CFLAGS are used for
600 # both target and host object files.
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700601 # There's a work-around called CFLAGS_FOR_BUILD and CFLAGS_FOR_TARGET
602 # but it does not seem to work properly. At least the host library
603 # libiberty is not compiled with CFLAGS_FOR_BUILD.
Stefan Reinauer45f77b82016-04-03 20:52:01 -0700604 # Also set the CXX version of the flags because GCC is now compiled
605 # using C++.
Patrick Georgi0a97d7e2016-01-25 09:51:22 +0100606 CC="$CC" CFLAGS_FOR_TARGET="-O2 -Dinhibit_libc" CFLAGS="$HOSTCFLAGS" \
Stefan Reinauer45f77b82016-04-03 20:52:01 -0700607 CFLAGS_FOR_BUILD="$HOSTCFLAGS" CXXFLAGS="$HOSTCFLAGS" \
608 CXXFLAGS_FOR_BUILD="$HOSTCFLAGS" ../gcc-${GCC_VERSION}/configure \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700609 --prefix=$TARGETDIR --libexecdir=$TARGETDIR/lib \
610 --target=${TARGETARCH} --disable-werror --disable-shared \
Stefan Reinauer2f97ebc2015-06-09 12:24:54 -0700611 --enable-lto --enable-plugins --enable-gold --enable-ld=default \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700612 --disable-libssp --disable-bootstrap --disable-nls \
613 --disable-libquadmath --without-headers \
Patrick Georgi0a97d7e2016-01-25 09:51:22 +0100614 --disable-threads \
Patrick Georgi1fc02d12016-03-23 21:44:43 +0100615 --enable-interwork --enable-multilib --enable-targets=all \
Patrick Georgi0a97d7e2016-01-25 09:51:22 +0100616 --disable-libatomic --disable-libcc1 --disable-decimal-float \
Nico Huberbb313bf2015-09-08 12:30:27 +0200617 ${GCC_OPTIONS} --enable-languages="${LANGUAGES}" \
Ronald G. Minnich7ee16b72016-02-12 21:54:59 +0000618 --with-system-zlib \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700619 --with-gmp=$DESTDIR$TARGETDIR --with-mpfr=$DESTDIR$TARGETDIR \
620 --with-mpc=$DESTDIR$TARGETDIR --with-libelf=$DESTDIR$TARGETDIR \
621 --with-pkgversion="coreboot toolchain v$CROSSGCC_VERSION $CROSSGCC_DATE" \
622 || touch .failed
623 $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-gcc || touch .failed
624 $MAKE install-gcc DESTDIR=$DESTDIR || touch .failed
625
Stefan Reinauerd7649122015-06-09 11:44:25 -0700626 if [ "$(echo $TARGETARCH | grep -c -- -mingw32)" -eq 0 ]; then
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700627 $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-target-libgcc || touch .failed
628 $MAKE install-target-libgcc DESTDIR=$DESTDIR || touch .failed
629 fi
630}
631
Nico Huber234d2462016-01-26 16:10:17 +0100632build_GCC() {
633 if [ "$1" = host ]; then
634 bootstrap_GCC
635 else
636 build_cross_GCC
637 fi
638}
639
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700640build_EXPAT() {
641 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${EXPAT_DIR}/configure --disable-shared \
Stefan Reinauera344b682016-04-21 19:29:51 -0700642 --prefix=$TARGETDIR || touch .failed
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700643 $MAKE || touch .failed
644 $MAKE install DESTDIR=$DESTDIR || touch .failed
645
646 normalize_dirs
647}
648
649build_PYTHON() {
650 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${PYTHON_DIR}/configure --prefix=$TARGETDIR \
Stefan Reinauera344b682016-04-21 19:29:51 -0700651 || touch .failed
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700652 $MAKE $JOBS || touch .failed
653 $MAKE install DESTDIR=$DESTDIR || touch .failed
654
655 normalize_dirs
656}
657
658build_GDB() {
659 export PYTHONHOME=$DESTDIR$TARGETDIR
660 if [ $(uname) != "FreeBSD" -a $(uname) != "NetBSD" ]; then
661 LIBDL="-ldl"
662 fi
663 LDFLAGS="-Wl,-rpath,\$\$ORIGIN/../lib/ -L$DESTDIR$TARGETDIR/lib \
664 -lpthread $LIBDL -lutil" \
665 CC="$CC" CFLAGS="$HOSTCFLAGS -I$DESTDIR$TARGETDIR/include" \
Stefan Reinauer7b40e422015-06-09 11:56:32 -0700666 ../${GDB_DIR}/configure --prefix=$TARGETDIR \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700667 --target=${TARGETARCH} --disable-werror --disable-nls
668 $MAKE $JOBS || touch .failed
669 $MAKE install DESTDIR=$DESTDIR || touch .failed
670}
671
672build_IASL() {
673 RDIR=$PWD
674 cd ../$IASL_DIR/generate/unix
675 CFLAGS="$HOSTCFLAGS"
676 HOST="_LINUX"
677 test $UNAME = "Darwin" && HOST="_APPLE"
678 test $UNAME = "FreeBSD" && HOST="_FreeBSD"
679 test $UNAME = "Cygwin" && HOST="_CYGWIN"
Martin Roth6f656132015-12-08 11:14:10 -0700680 HOST="$HOST" OPT_CFLAGS="-O -D_FORTIFY_SOURCE=2 -D COREBOOT_TOOLCHAIN_VERSION='\"coreboot toolchain v$CROSSGCC_VERSION $CROSSGCC_DATE\"' " CFLAGS="$CFLAGS" $MAKE CC="$CC" iasl || touch $RDIR/.failed
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700681 rm -f $DESTDIR$TARGETDIR/bin/iasl || touch $RDIR/.failed
682 cp bin/iasl $DESTDIR$TARGETDIR/bin || touch $RDIR/.failed
683}
684
685build_LLVM() {
686 cd ..
687 ln -sf $PWD/$CFE_DIR $LLVM_DIR/tools/clang
688 ln -sf $PWD/$CTE_DIR $LLVM_DIR/tools/clang/tools/extra
689 ln -sf $PWD/$CRT_DIR $LLVM_DIR/projects/compiler-rt
690 cd -
691
692 $CMAKE -G "Unix Makefiles" -DCMAKE_INSTALL_PREFIX=$DESTDIR$TARGETDIR \
Martin Rothfb5647a2015-12-18 09:26:45 -0700693 -DCLANG_VENDOR="coreboot toolchain v$CROSSGCC_VERSION $CROSSGCC_DATE - " \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700694 -DCMAKE_BUILD_TYPE=Release ../$LLVM_DIR || touch .failed
695 $MAKE $JOBS || touch .failed
696 $MAKE install || touch .failed
697
698 cp -a ../$CFE_DIR/tools/scan-build/* $DESTDIR$TARGETDIR/bin
699 cp -a ../$CFE_DIR/tools/scan-view/* $DESTDIR$TARGETDIR/bin
Stefan Reinauere9e6e3d2015-07-07 00:20:42 +0200700
701 # create symlinks to work around broken --print-librt-file-name
702 # when used with -target.
703 cd $DESTDIR$TARGETDIR/lib/clang/${CLANG_VERSION}/lib
704 for i in */libclang_rt.builtins*.a; do
705 ln -s $i .
706 done
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700707}
708
Stefan Reinauera851bbb2016-01-29 18:03:26 -0800709build_MAKE() {
710 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${MAKE_DIR}/configure --prefix=$TARGETDIR \
711 --disable-nls || touch .failed
712 $MAKE $JOBS || touch .failed
713 $MAKE install DESTDIR=$DESTDIR || touch .failed
714
715 normalize_dirs
716}
717
Martin Rothedf965a2015-11-25 16:58:33 -0700718print_stable() {
719 case "$PRINTSTABLE" in
720 AUTOCONF|autoconf) printf "%s\n" "$GCC_AUTOCONF_VERSION";;
721 BINUTILS|binutils) printf "%s\n" "$BINUTILS_VERSION";;
722 CLANG|clang) printf "%s\n" "$CLANG_VERSION";;
723 EXPAT|expat) printf "%s\n" "$EXPAT_VERSION";;
724 GCC|gcc) printf "%s\n" "$GCC_VERSION";;
725 GDB|gdb) printf "%s\n" "$GDB_VERSION";;
726 GMP|gmp) printf "%s\n" "$GMP_VERSION";;
727 IASL|iasl) printf "%s\n" "$IASL_VERSION";;
728 LIBELF|libelf) printf "%s\n" "$LIBELF_VERSION";;
729 MPC|mpc) printf "%s\n" "$MPC_VERSION";;
730 MPFR|mpfr) printf "%s\n" "$MPFR_VERSION";;
731 PYTHON|python) printf "%s\n" "$PYTHON_VERSION";;
Stefan Reinauera851bbb2016-01-29 18:03:26 -0800732 MAKE|make) printf "%s\n" "$MAKE_VERSION";;
Martin Rothedf965a2015-11-25 16:58:33 -0700733 *) printf "Unknown tool %s\n" "$PRINTSTABLE";;
734 esac
735}
Stefan Reinauer074d9132009-09-26 16:43:17 +0000736
Zheng Baobb003c82016-08-05 13:41:51 +0800737trap quit 1 2 3 15
738
Patrick Georgi6bba29f2010-01-29 17:40:52 +0000739# Look if we have getopt. If not, build it.
740export PATH=$PATH:.
741getopt - > /dev/null 2>/dev/null || gcc -o getopt getopt.c
742
Stefan Reinauer074d9132009-09-26 16:43:17 +0000743# parse parameters.. try to find out whether we're running GNU getopt
Stefan Reinauerd7649122015-06-09 11:44:25 -0700744getoptbrand="$(getopt -V | sed -e '1!d' -e 's,^\(......\).*,\1,')"
Peter Stuge09377b72011-08-21 06:24:55 +0200745if [ "${getoptbrand}" = "getopt" ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000746 # Detected GNU getopt that supports long options.
Nico Hubercc414dd2016-09-20 13:59:38 +0200747 args=$(getopt -l version,help,clean,directory:,bootstrap,platform:,languages:,package:,jobs:,destdir:,savetemps,scripting,ccache,supported:,urls,nocolor -o Vhcd:bp:l:P:j:D:tSys:un -- "$@")
Nico Huber78df0bf2016-09-20 14:11:53 +0200748 getopt_ret=$?
Nico Hubercc414dd2016-09-20 13:59:38 +0200749 eval set -- "$args"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000750else
751 # Detected non-GNU getopt
Nico Huber152e78e2016-09-20 15:38:40 +0200752 args=$(getopt Vhcd:bp:l:P:j:D:tSys:un $*)
Nico Huber78df0bf2016-09-20 14:11:53 +0200753 getopt_ret=$?
Stefan Reinauer074d9132009-09-26 16:43:17 +0000754 set -- $args
755fi
756
Nico Huber78df0bf2016-09-20 14:11:53 +0200757if [ $getopt_ret != 0 ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000758 myhelp
759 exit 1
760fi
761
762while true ; do
763 case "$1" in
764 -V|--version) shift; myversion; exit 0;;
765 -h|--help) shift; myhelp; exit 0;;
Patrick Georgi44af57a2013-12-19 22:06:22 +0100766 -c|--clean) shift; clean=1;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000767 -t|--savetemps) shift; SAVETEMPS=1;;
768 -d|--directory) shift; TARGETDIR="$1"; shift;;
Nico Huber234d2462016-01-26 16:10:17 +0100769 -b|--bootstrap) shift; BOOTSTRAP=1;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000770 -p|--platform) shift; TARGETARCH="$1"; shift;;
Nico Huberbb313bf2015-09-08 12:30:27 +0200771 -l|--languages) shift; LANGUAGES="$1"; shift;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000772 -D|--destdir) shift; DESTDIR="$1"; shift;;
Patrick Georgi73166c72010-04-14 20:42:42 +0000773 -j|--jobs) shift; JOBS="-j $1"; shift;;
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700774 -P|--package) shift; PACKAGE="$1"; shift;;
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100775 -S|--scripting) shift; SKIPPYTHON=0;;
Patrick Georgic1a75b12011-11-04 21:37:14 +0100776 -y|--ccache) shift; USECCACHE=1;;
Martin Rothedf965a2015-11-25 16:58:33 -0700777 -s|--supported) shift; PRINTSTABLE="$1"; shift;;
Nico Huber152e78e2016-09-20 15:38:40 +0200778 -u|--urls) shift; printf "%s\n" "$ALL_ARCHIVES"; exit 0;;
779 -n|--nocolor) shift; \
Martin Roth4a53db02016-03-01 15:21:07 -0700780 unset red RED green GREEN blue BLUE cyan CYAN NC;;
Patrick Georgid2e0dd52013-06-09 08:05:45 +0200781 --) shift; break;;
Patrick Georgid2e0dd52013-06-09 08:05:45 +0200782 *) break;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000783 esac
784done
785
Nico Huberbd74d562016-09-20 14:16:43 +0200786if [ $# -gt 0 ]; then
787 printf "Excessive arguments: $*\n"
788 myhelp
789 exit 1
790fi
791
Martin Rothedf965a2015-11-25 16:58:33 -0700792if [ -n "$PRINTSTABLE" ]; then
793 print_stable
794 exit 0
795fi
796
797#print toolchain builder version string as the header
798printversion
799
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700800case "$TARGETARCH" in
Timothy Pearsona9f62352015-12-30 18:59:00 -0600801 x86_64-elf) ;;
802 x86_64*) TARGETARCH=x86_64-elf;;
803 i386-elf) ;;
804 i386-mingw32) ;;
805 mipsel-elf) ;;
Iru Caiae8e3a02016-04-02 10:50:59 +0800806 riscv-elf) TARGETARCH=riscv64-elf;;
Patrick Georgi0a97d7e2016-01-25 09:51:22 +0100807 powerpc64*-linux*) ;;
Timothy Pearsona9f62352015-12-30 18:59:00 -0600808 i386*) TARGETARCH=i386-elf;;
Stefan Reinauer27522ad2016-01-29 17:31:34 -0800809 arm*) TARGETARCH=arm-eabi;;
Timothy Pearsona9f62352015-12-30 18:59:00 -0600810 aarch64*) TARGETARCH=aarch64-elf;;
Martin Roth3e0f74d2016-03-08 12:07:04 -0700811 nds32le-elf) ;;
Timothy Pearsona9f62352015-12-30 18:59:00 -0600812 *) printf "${red}WARNING: Unsupported architecture $TARGETARCH.${NC}\n\n"; ;;
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700813esac
814
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700815# Figure out which packages to build
Stefan Reinauer699ac272015-06-05 12:43:28 -0700816
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700817case "$PACKAGE" in
818 GCC|gcc)
819 echo "Target architecture is now $TARGETARCH"
820 NAME="${TARGETARCH} cross GCC"
Stefan Reinauerbd8b2e32015-06-17 11:55:02 -0700821 PACKAGES="GMP MPFR MPC LIBELF BINUTILS GCC"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700822 ;;
823 GDB|gdb)
824 NAME="${TARGETARCH} cross GDB"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700825 if [ $SKIPPYTHON -eq 0 ]; then
Ronald G. Minnichfb944f42016-02-27 04:06:42 +0000826 PACKAGES="EXPAT PYTHON GDB"
827 else
828 PACKAGES="EXPAT GDB"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700829 fi
830 ;;
831 CLANG|clang)
832 NAME=clang
833 PACKAGES="LLVM CFE CRT CTE"
David Hendrickscd5cdd32015-06-15 17:03:22 -0700834 CMAKE=$(searchtool cmake "cmake") || exit $?
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700835 ;;
836 IASL|iasl)
837 NAME="IASL ACPI compiler"
838 PACKAGES=IASL
839 ;;
Stefan Reinauera851bbb2016-01-29 18:03:26 -0800840 MAKE|make)
841 NAME="GNU Make"
842 PACKAGES=MAKE
843 ;;
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700844 *)
Stefan Reinauera851bbb2016-01-29 18:03:26 -0800845 printf "${red}ERROR: Unsupported package $PACKAGE. (Supported packages are GCC, GDB, CLANG, IASL, MAKE)${NC}\n\n";
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700846 exit 1
847 ;;
848esac
Peter Stugeceacd772011-06-09 04:54:16 +0200849
Stefan Reinauer66e93352015-06-16 22:38:23 +0200850# Find all the required tools:
851
852TAR=$(searchtool tar) || exit $?
853PATCH=$(searchtool patch) || exit $?
854MAKE=$(searchtool make) || exit $?
855SHA1SUM=$(searchtool sha1sum)
zbao5cf758d2015-09-01 22:28:57 -0400856#SHA512SUM=$(searchtool sha512sum)
857#MD5SUM=$(searchtool md5sum)
Stefan Reinauer66e93352015-06-16 22:38:23 +0200858CHECKSUM=$SHA1SUM
Martin Roth95f7b222016-03-20 12:38:48 -0600859LBZIP2=$(searchtool lbzip2 "" nofail)
860PIGZ=$(searchtool pigz "" nofail)
Stefan Reinauer66e93352015-06-16 22:38:23 +0200861
862searchtool m4 > /dev/null
863searchtool bison > /dev/null
864searchtool flex flex > /dev/null
865searchtool g++ "Free Software Foundation" nofail > /dev/null || \
Marc Jones5ee69512015-06-17 15:38:17 -0600866searchtool clang "clang version" nofail > /dev/null || \
Martin Rothe3963172016-01-06 13:54:32 -0700867searchtool clang "LLVM" "" "g++" > /dev/null
Stefan Reinauer66e93352015-06-16 22:38:23 +0200868searchtool wget > /dev/null
869searchtool bzip2 "bzip2," > /dev/null
870
Martin Roth591790f2016-03-20 20:39:04 -0600871check_for_library "-lz" "zlib (zlib1g-dev or zlib-devel)"
872
Nico Huber156d87c2016-09-20 12:59:53 +0200873CC=cc
874check_cc
875
Martin Roth88463822016-01-07 11:03:36 -0700876if [ "$HALT_FOR_TOOLS" -ne 0 ]; then
877 exit 1
878fi
879
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700880# This initial cleanup is useful when updating the toolchain script.
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000881
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700882if [ "$clean" = "1" ]; then
883 cleanup
884fi
Stefan Reinauer074d9132009-09-26 16:43:17 +0000885
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700886# Set up host compiler and flags needed for various OSes
Stefan Reinauer074d9132009-09-26 16:43:17 +0000887
Patrick Georgif2c15f52015-06-11 21:07:31 +0200888if is_package_enabled "GCC"; then
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700889if [ $UNAME = "Darwin" ]; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000890 #GCC_OPTIONS="$GCC_OPTIONS --enable-threads=posix"
891
892 # generally the OS X compiler can create x64 binaries.
893 # Per default it generated i386 binaries in 10.5 and x64
894 # binaries in 10.6 (even if the kernel is 32bit)
895 # For some weird reason, 10.5 autodetects an ABI=64 though
896 # so we're setting the ABI explicitly here.
Stefan Reinauerd7649122015-06-09 11:44:25 -0700897 if [ $(sysctl -n hw.optional.x86_64 2>/dev/null) -eq 1 ] 2>/dev/null; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000898 OPTIONS="ABI=64"
899 else
900 OPTIONS="ABI=32"
901 fi
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700902
Stefan Reinauer4266b922012-12-05 16:18:32 -0800903 # In Xcode 4.5.2 the default compiler is clang.
904 # However, this compiler fails to compile gcc 4.7.x. As a
905 # workaround it's possible to compile gcc with llvm-gcc.
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700906 if $CC -v 2>&1 | grep -q LLVM; then
Stefan Reinauer4266b922012-12-05 16:18:32 -0800907 CC=llvm-gcc
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700908 fi
zbao11f1d312015-08-05 23:15:54 -0400909elif [ $UNAME = "Linux" -o $UNAME = "Cygwin" ]; then
Patrick Georgiddb8f802015-07-04 17:45:54 +0200910 # gmp is overeager with detecting 64bit CPUs even if they run
911 # a 32bit kernel and userland.
912 if [ "$(uname -m 2>/dev/null)" = "i686" ]; then
913 OPTIONS="ABI=32"
914 fi
Nico Huberde45c592016-01-20 23:22:33 +0100915elif [ $UNAME = "NetBSD" ]; then
916 # same for NetBSD but this one reports an i386
917 if [ "$(uname -m 2>/dev/null)" = "i386" ]; then
918 OPTIONS="ABI=32"
919 fi
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000920fi
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700921fi # GCC
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000922
Nico Huber5f72f962016-01-31 23:05:19 +0100923export HOSTCFLAGS="-Os"
924if have_hostcflags_from_gmp; then
925 set_hostcflags_from_gmp
926fi
927
Patrick Georgic1a75b12011-11-04 21:37:14 +0100928if [ "$USECCACHE" = 1 ]; then
929 CC="ccache $CC"
930fi
931
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700932# Prepare target directory for building GCC
933# (dependencies must be in the PATH)
Stefan Reinauer16bd7892012-12-07 23:57:01 +0100934mkdir -p $DESTDIR$TARGETDIR/bin
Stefan Reinauer88352d72016-04-06 15:57:03 -0700935mkdir -p $DESTDIR$TARGETDIR/share
Stefan Reinauer16bd7892012-12-07 23:57:01 +0100936export PATH=$DESTDIR$TARGETDIR/bin:$PATH
937
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700938# Download, unpack, patch and build all packages
939
Martin Roth03625172016-02-17 14:44:14 -0700940printf "Downloading tarballs ... \n"
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700941mkdir -p tarballs
942for P in $PACKAGES; do
943 download $P
944done
Martin Roth03625172016-02-17 14:44:14 -0700945printf "Downloaded tarballs ... ${green}ok${NC}\n"
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700946
947printf "Unpacking and patching ... \n"
948for P in $PACKAGES; do
949 unpack_and_patch $P || exit 1
950done
951printf "Unpacked and patched ... ${green}ok${NC}\n"
952
953printf "Building packages ... \n"
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700954for package in $PACKAGES; do
955 build $package
956done
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700957printf "Packages built ... ${green}ok${NC}\n"
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700958
Stefan Reinauer699ac272015-06-05 12:43:28 -0700959# Adding git information of current tree to target directory
960# for reproducibility
Stefan Reinauerd7649122015-06-09 11:44:25 -0700961PROGNAME=$(basename "$0")
Stefan Reinauer88352d72016-04-06 15:57:03 -0700962rm -f "$DESTDIR$TARGETDIR/share/$PROGNAME-*"
963cp "$PROGNAME" "$DESTDIR$TARGETDIR/share/$PROGNAME-$CROSSGCC_VERSION-$CROSGCC_COMMIT"
Zheng Bao30b895f2013-02-06 18:04:40 +0800964
Stefan Reinauer88e83e52016-04-06 15:39:48 -0700965cleanup
Stefan Reinauer074d9132009-09-26 16:43:17 +0000966
Stefan Reinauer699ac272015-06-05 12:43:28 -0700967printf "\n${green}You can now run your $NAME toolchain from $TARGETDIR.${NC}\n"